<template>
  <div>
    <h2 class="font-medium ">{{ question.title }} <span>{{ !question.isEmpty ? '*' : '' }}</span></h2>
    <el-text v-if="question.description">{{ question.description }}</el-text>
    <div class="mt-1 max-w-sm">
      <el-input v-model="input" :placeholder="question.title"/>
      <el-text v-if="error" class="mx-1" type="danger">{{ error }}</el-text>
    </div>
  </div>
</template>

<script setup>
import { ref, watch, computed, onMounted } from 'vue'

const props = defineProps({
  question: {
    type: Object
  },
  userAnswers: {
    type: Array
  },
  handleUserAnswer: {
    type: Function
  }
})

const findPreValue = () => {
  let value = ''
  const index = props.userAnswers.findIndex((item) => item.question.name === props.question.name)
  if (index !== -1) {
    value = props.userAnswers[index][props.question.type]
  }

  return value
}

const error = computed(
  () => props.userAnswers.find((item) => item.question.name === props.question.name)?.error || ''
)

const input = ref(findPreValue())

const updateInput = () => {
  props.handleUserAnswer({ question:props.question, ans: input.value })
}

watch(
  () => props.question,
  () => {
    input.value = findPreValue()
  }
)

onMounted(() => {
  if(!input.value){
    console.log('called')
    updateInput()
  }
})

watch(input, () => {
  updateInput()
})
</script>
